﻿using System;
using System.Net;
using System.Windows;
using System.Threading;

namespace MSUS.Silverlight.Thmx2Theme.Controls
{
    /// <summary>
    /// An IAsyncResult implementation used by the ThmxLoader
    /// </summary>
    internal class ThmxAsyncResult : IAsyncResult
    {
        private object _asyncState;
        private bool _isCompleted;
        AsyncCallback _callback;

        public ThmxAsyncResult(AsyncCallback callback)
        {
            AsyncWaitHandle = new AutoResetEvent(false);
            _callback = callback;
        }

        public object AsyncState
        {
            get
            {
                return _asyncState;
            }
            set
            {
                _asyncState = value;
            }
        }
        public WaitHandle AsyncWaitHandle
        {
            get;
            private set;
        }
        public bool CompletedSynchronously
        {
            get;
            internal set;
        }
        public bool IsCompleted
        {
            get { return _isCompleted; }
            internal set
            {
                if (value == _isCompleted)
                    return;

                _isCompleted = value;
                if (_isCompleted)
                {
                    ((AutoResetEvent)AsyncWaitHandle).Set();
                    _callback(this);
                }
            }
        }
    }
}
