﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Web.UI.HtmlControls;

namespace ThemeSilverlightRegWebPart.SilverlightRegPart
{
    [ToolboxItemAttribute(false)]
    public class SilverlightRegPart : WebPart
    {
        private static string XAP_FILE = "MSUS.Silverlight.Thmx2Theme.Client.xap";

        protected override void CreateChildControls()
        {
            /// This is a very quick and simple web part used in our sample to render an object tag
            ///
            /// 
            /// We assume the site asset library exists with a  path of <site>/SiteAsset
            ///     and our .xap file is deployed to this location
            ///     
            string url = Microsoft.SharePoint.SPContext.Current.Web.Url + "/SiteAssets/" + XAP_FILE;

            //Render the Silverlight object tag
            HtmlGenericControl oTag = new HtmlGenericControl("object");
            oTag.Attributes.Add("data", "data:application/x-silverlight-2");
            oTag.Attributes.Add("type", "application/x-silverlight-2");
            oTag.Attributes.Add("width", "440");
            oTag.Attributes.Add("height", "310");

            oTag.Controls.Add(createParamControl("source", url));
            oTag.Controls.Add(createParamControl("background", "white"));
            oTag.Controls.Add(createParamControl("minRuntimeVersion", "4.0.50303.0"));
            oTag.Controls.Add(createParamControl("autoUpgrade", "true"));
            oTag.Controls.Add(createParamControl("initParams", "thmxUrl=" + Microsoft.SharePoint.Utilities.ThmxTheme.GetThemeUrlForWeb(Microsoft.SharePoint.SPContext.Current.Web)));

            HtmlAnchor aTag = new HtmlAnchor();
            aTag.HRef = "http://go.microsoft.com/fwlink/?LinkID=149156&v=4.0.50303.0";
            aTag.Style.Clear();

            HtmlImage iTag = new HtmlImage();
            iTag.Src = "http://go.microsoft.com/fwlink/?LinkId=161376";
            iTag.Alt = "Get Microsoft Silverlight";
            iTag.Border = 0;
            iTag.Style.Clear();
            aTag.Controls.Add(iTag);

            oTag.Controls.Add(aTag);
            this.Controls.Add(oTag);
        }

        HtmlGenericControl createParamControl(string name, string val)
        {
            HtmlGenericControl param = new HtmlGenericControl("param");
            param.Attributes.Add("name", name);
            param.Attributes.Add("value", val);
            return param;
        }
    }
}
